Index: django/db/backends/mysql/introspection.py
===================================================================
--- django/db/backends/mysql/introspection.py	(revision 17914)
+++ django/db/backends/mysql/introspection.py	(working copy)
@@ -1,3 +1,4 @@
+from django.db import QName
 from django.db.backends import BaseDatabaseIntrospection
 from MySQLdb import ProgrammingError, OperationalError
 from MySQLdb.constants import FIELD_TYPE
@@ -28,30 +29,44 @@
         FIELD_TYPE.VAR_STRING: 'CharField',
     }
 
-    def get_table_list(self, cursor):
-        "Returns a list of table names in the current database."
-        cursor.execute("SHOW TABLES")
-        return [row[0] for row in cursor.fetchall()]
+    def get_visible_tables_list(self, cursor):
+        "Returns a list of visible tables"
+        return self.get_qualified_tables_list(cursor, [self.connection.settings_dict['NAME']])
 
-    def get_table_description(self, cursor, table_name):
+    def get_qualified_tables_list(self, cursor, schemas):
+        default_schema = self.connection.convert_schema(None)
+        if default_schema:
+            schemas.append(default_schema)
+        if not schemas:
+            return []
+        param_list = ', '.join(['%s']*len(schemas))
+        cursor.execute("""
+            SELECT table_schema, table_name
+              FROM information_schema.tables
+             WHERE table_schema in (%s)""" % param_list, schemas)
+        return [QName(row[0], row[1], True) for row in cursor.fetchall()]
+
+    def get_table_description(self, cursor, qname):
         "Returns a description of the table, with the DB-API cursor.description interface."
-        cursor.execute("SELECT * FROM %s LIMIT 1" % self.connection.ops.quote_name(table_name))
+        qname = self.qname_converter(qname)
+        cursor.execute("SELECT * FROM %s LIMIT 1"
+                       % self.connection.ops.qualified_name(qname))
         return cursor.description
 
-    def _name_to_index(self, cursor, table_name):
+    def _name_to_index(self, cursor, qname):
         """
         Returns a dictionary of {field_name: field_index} for the given table.
         Indexes are 0-based.
         """
-        return dict([(d[0], i) for i, d in enumerate(self.get_table_description(cursor, table_name))])
+        return dict((d[0], i) for i, d in enumerate(self.get_table_description(cursor, qname)))
 
-    def get_relations(self, cursor, table_name):
+    def get_relations(self, cursor, qname):
         """
         Returns a dictionary of {field_index: (field_index_other_table, other_table)}
         representing all relationships to the given table. Indexes are 0-based.
         """
-        my_field_dict = self._name_to_index(cursor, table_name)
-        constraints = self.get_key_columns(cursor, table_name)
+        my_field_dict = self._name_to_index(cursor, qname)
+        constraints = self.get_key_columns(cursor, qname)
         relations = {}
         for my_fieldname, other_table, other_field in constraints:
             other_field_index = self._name_to_index(cursor, other_table)[other_field]
@@ -59,25 +74,32 @@
             relations[my_field_index] = (other_field_index, other_table)
         return relations
 
-    def get_key_columns(self, cursor, table_name):
+    def get_key_columns(self, cursor, qname):
         """
-        Returns a list of (column_name, referenced_table_name, referenced_column_name) for all
-        key columns in given table.
+        Returns a list of
+            (column_name,
+            (reference_table_schema, referenced_table_name),
+            referenced_column_name)
+        for all key columns in given table.
         """
         key_columns = []
+        qname = self.qname_converter(qname, force_schema=True)
         try:
             cursor.execute("""
-                SELECT column_name, referenced_table_name, referenced_column_name
+                SELECT column_name, referenced_table_schema, referenced_table_name, referenced_column_name
                 FROM information_schema.key_column_usage
-                WHERE table_name = %s
-                    AND table_schema = DATABASE()
+                WHERE table_schema = %s
+                    AND table_name = %s
                     AND referenced_table_name IS NOT NULL
-                    AND referenced_column_name IS NOT NULL""", [table_name])
-            key_columns.extend(cursor.fetchall())
+                    AND referenced_column_name IS NOT NULL""",
+                           [qname.schema, qname.table])
+            for row in cursor.fetchall():
+                key_columns.append((row[0], QName(row[1], row[2], True),
+                                    row[3]))
         except (ProgrammingError, OperationalError):
             # Fall back to "SHOW CREATE TABLE", for previous MySQL versions.
             # Go through all constraints and save the equal matches.
-            cursor.execute("SHOW CREATE TABLE %s" % self.connection.ops.quote_name(table_name))
+            cursor.execute("SHOW CREATE TABLE %s" % self.connection.ops.qualified_name(qname))
             for row in cursor.fetchall():
                 pos = 0
                 while True:
@@ -85,28 +107,47 @@
                     if match == None:
                         break
                     pos = match.end()
-                    key_columns.append(match.groups())
+                    groups = match.groups()
+                    tblname = groups[1]
+                    if '.' in tblname:
+                        tblname = tblname.split('.')
+                    else:
+                        tblname = None, tblname
+                    key_columns.append((groups[0], tblname, groups[2]))
         return key_columns
 
-    def get_primary_key_column(self, cursor, table_name):
+    def get_primary_key_column(self, cursor, qname):
         """
         Returns the name of the primary key column for the given table
         """
-        for column in self.get_indexes(cursor, table_name).iteritems():
+        for column in self.get_indexes(cursor, qname).iteritems():
             if column[1]['primary_key']:
                 return column[0]
         return None
 
-    def get_indexes(self, cursor, table_name):
+    def get_indexes(self, cursor, qname):
         """
         Returns a dictionary of fieldname -> infodict for the given table,
         where each infodict is in the format:
             {'primary_key': boolean representing whether it's the primary key,
              'unique': boolean representing whether it's a unique index}
         """
-        cursor.execute("SHOW INDEX FROM %s" % self.connection.ops.quote_name(table_name))
+        qname = self.qname_converter(qname)
+        cursor.execute("SHOW INDEX FROM %s" % self.connection.ops.qualified_name(qname))
         indexes = {}
         for row in cursor.fetchall():
             indexes[row[4]] = {'primary_key': (row[2] == 'PRIMARY'), 'unique': not bool(row[1])}
         return indexes
 
+    def get_schema_list(self, cursor):
+        cursor.execute("SHOW DATABASES")
+        return [r[0] for r in cursor.fetchall()]
+
+    def qname_converter(self, qname, force_schema=False):
+        assert isinstance(qname, QName)
+        if qname.db_format and (qname.schema or not force_schema):
+            return qname
+        schema = self.connection.convert_schema(qname.schema)
+        if not schema and force_schema:
+            schema = self.connection.settings_dict['NAME']
+        return QName(schema, qname.table, True)
Index: django/db/backends/mysql/creation.py
===================================================================
--- django/db/backends/mysql/creation.py	(revision 17914)
+++ django/db/backends/mysql/creation.py	(working copy)
@@ -1,3 +1,4 @@
+from django.db import QName
 from django.db.backends.creation import BaseDatabaseCreation
 
 class DatabaseCreation(BaseDatabaseCreation):
@@ -58,9 +59,41 @@
             style.SQL_KEYWORD('NOT NULL'))
         ]
         deferred = [
-            (field.m2m_db_table(), field.m2m_column_name(), opts.db_table,
+            (field.m2m_qualified_table(), field.m2m_column_name(), opts.qualified_name,
                 opts.pk.column),
-            (field.m2m_db_table(), field.m2m_reverse_name(),
-                field.rel.to._meta.db_table, field.rel.to._meta.pk.column)
+            (field.m2m_qualified_table(), field.m2m_reverse_name(),
+                field.rel.to._meta.qualified_name, field.rel.to._meta.pk.column)
             ]
         return table_output, deferred
+
+    def sql_destroy_schema(self, schema, style):
+        qn = self.connection.ops.quote_name
+        return "%s %s;" % (style.SQL_KEYWORD('DROP DATABASE'), qn(schema))
+    
+    def qualified_index_name(self, model, col):
+        """
+        On MySQL we must use the db_schema prefixed to the index name as
+        indexes can not be placed into different schemas.
+        """
+        from django.db.backends.util import truncate_name
+        schema = model._meta.db_schema or self.connection.schema
+        max_len = self.connection.ops.max_name_length()
+        schema_prefix = ''
+        if schema:
+             schema = self.connection.convert_schema(schema)
+             schema_prefix = truncate_name(schema, max_len / 2) + '_'
+        i_name = '%s%s_%s' % (schema_prefix, model._meta.db_table, self._digest(col))
+        i_name = self.connection.ops.quote_name(truncate_name(i_name, max_len))
+        return i_name
+
+    def qualified_name_for_ref(self, from_table, ref_table):
+        """
+        MySQL does not have qualified name format for indexes, so make sure to
+        use qualified names if needed.
+        """
+        from_qn = self.connection.introspection.qname_converter(from_table)
+        to_qn = self.connection.introspection.qname_converter(ref_table)
+        if to_qn.schema is None:
+            to_qn = QName(self.connection.settings_dict['NAME'],
+                          to_qn.table, to_qn.db_format)
+        return super(DatabaseCreation, self).qualified_name_for_ref(from_qn, to_qn)
Index: django/db/backends/mysql/base.py
===================================================================
--- django/db/backends/mysql/base.py	(revision 17914)
+++ django/db/backends/mysql/base.py	(working copy)
@@ -15,6 +15,8 @@
     from django.core.exceptions import ImproperlyConfigured
     raise ImproperlyConfigured("Error loading MySQLdb module: %s" % e)
 
+from django.db.backends.util import truncate_name
+
 # We want version (1, 2, 1, 'final', 2) or later. We can't just use
 # lexicographic ordering in this check because then (1, 2, 1, 'gamma')
 # inadvertently passes the version test.
@@ -187,6 +189,10 @@
         "Confirm support for introspected foreign keys"
         return self._mysql_storage_engine() != 'MyISAM'
 
+    def confirm(self):
+        super(DatabaseFeatures, self).confirm()
+        self.supports_foreign_keys != self.can_introspect_foreign_keys
+
 class DatabaseOperations(BaseDatabaseOperations):
     compiler_module = "django.db.backends.mysql.compiler"
 
@@ -245,6 +251,16 @@
             return name # Quoting once is enough.
         return "`%s`" % name
 
+    def qualified_name(self, qname):
+        schema = qname.schema
+        if not qname.db_format:
+            schema = self.connection.convert_schema(schema)
+        if schema:
+            return "%s.%s" % (self.quote_name(schema),
+                              self.quote_name(qname.table))
+        else:
+            return self.quote_name(qname.table)
+
     def random_function_sql(self):
         return 'RAND()'
 
@@ -255,7 +271,9 @@
         if tables:
             sql = ['SET FOREIGN_KEY_CHECKS = 0;']
             for table in tables:
-                sql.append('%s %s;' % (style.SQL_KEYWORD('TRUNCATE'), style.SQL_FIELD(self.quote_name(table))))
+                sql.append('%s %s;'
+                           % (style.SQL_KEYWORD('TRUNCATE'),
+                              style.SQL_FIELD(self.qualified_name(table))))
             sql.append('SET FOREIGN_KEY_CHECKS = 1;')
 
             # 'ALTER TABLE table AUTO_INCREMENT = 1;'... style SQL statements
@@ -263,7 +281,7 @@
             sql.extend(["%s %s %s %s %s;" % \
                 (style.SQL_KEYWORD('ALTER'),
                  style.SQL_KEYWORD('TABLE'),
-                 style.SQL_TABLE(self.quote_name(sequence['table'])),
+                 style.SQL_TABLE(self.qualified_name((sequence['qname']))),
                  style.SQL_KEYWORD('AUTO_INCREMENT'),
                  style.SQL_FIELD('= 1'),
                 ) for sequence in sequences])
@@ -347,6 +365,13 @@
         self.creation = DatabaseCreation(self)
         self.introspection = DatabaseIntrospection(self)
         self.validation = DatabaseValidation(self)
+    
+    def convert_schema(self, schema):
+        schema = schema or self.schema
+        if schema and self.test_schema_prefix:
+            return truncate_name('%s%s' % (self.test_schema_prefix, schema),
+                                 self.ops.max_name_length())
+        return schema
 
     def _valid_connection(self):
         if self.connection is not None:
@@ -442,8 +467,9 @@
         ALL IMMEDIATE")
         """
         cursor = self.cursor()
+        qn3 = self.ops.qualified_name
         if table_names is None:
-            table_names = self.introspection.get_table_list(cursor)
+            table_names = self.introspection.get_visible_tables_list(cursor)
         for table_name in table_names:
             primary_key_column_name = self.introspection.get_primary_key_column(cursor, table_name)
             if not primary_key_column_name:
@@ -451,15 +477,17 @@
             key_columns = self.introspection.get_key_columns(cursor, table_name)
             for column_name, referenced_table_name, referenced_column_name in key_columns:
                 cursor.execute("""
-                    SELECT REFERRING.`%s`, REFERRING.`%s` FROM `%s` as REFERRING
-                    LEFT JOIN `%s` as REFERRED
+                    SELECT REFERRING.`%s`, REFERRING.`%s` FROM %s as REFERRING
+                    LEFT JOIN %s as REFERRED
                     ON (REFERRING.`%s` = REFERRED.`%s`)
                     WHERE REFERRING.`%s` IS NOT NULL AND REFERRED.`%s` IS NULL"""
-                    % (primary_key_column_name, column_name, table_name, referenced_table_name,
-                    column_name, referenced_column_name, column_name, referenced_column_name))
+                    % (primary_key_column_name, column_name, qn3(table_name),
+                       qn3(referenced_table_name), column_name,
+                       referenced_column_name, column_name,
+                       referenced_column_name))
                 for bad_row in cursor.fetchall():
                     raise utils.IntegrityError("The row in table '%s' with primary key '%s' has an invalid "
                         "foreign key: %s.%s contains a value '%s' that does not have a corresponding value in %s.%s."
-                        % (table_name, bad_row[0],
-                        table_name, column_name, bad_row[1],
-                        referenced_table_name, referenced_column_name))
+                        % (table_name[1], bad_row[0],
+                        table_name[1], column_name, bad_row[1],
+                        referenced_table_name[1], referenced_column_name))
Index: django/db/backends/oracle/base.py
===================================================================
--- django/db/backends/oracle/base.py	(revision 17914)
+++ django/db/backends/oracle/base.py	(working copy)
@@ -4,12 +4,12 @@
 Requires cx_Oracle: http://cx-oracle.sourceforge.net/
 """
 
-
 import datetime
 import decimal
 import sys
 import warnings
 
+from django.db import QName
 
 def _setup_environment(environ):
     import platform
@@ -48,6 +48,7 @@
 from django.conf import settings
 from django.db import utils
 from django.db.backends import *
+from django.db.backends.util import truncate_name
 from django.db.backends.signals import connection_created
 from django.db.backends.oracle.client import DatabaseClient
 from django.db.backends.oracle.creation import DatabaseCreation
@@ -87,34 +88,42 @@
 class DatabaseOperations(BaseDatabaseOperations):
     compiler_module = "django.db.backends.oracle.compiler"
 
-    def autoinc_sql(self, table, column):
+    def autoinc_sql(self, qname, column):
         # To simulate auto-incrementing primary keys in Oracle, we have to
         # create a sequence and a trigger.
-        sq_name = self._get_sequence_name(table)
-        tr_name = self._get_trigger_name(table)
-        tbl_name = self.quote_name(table)
-        col_name = self.quote_name(column)
+        seq_name = self._get_sequence_name(qname)
+        schema = seq_name.schema.upper()
+        sname = self.connection.ops.qualified_name(seq_name).upper()
+        params = {
+            'sq_name': seq_name.table,
+            'schema': schema,
+            'qualified_sq_name': sname,
+            'tr_name': self._get_trigger_name(qname),
+            'tbl_name': self.qualified_name(qname),
+            'col_name' : self.quote_name(column),
+        }
         sequence_sql = """
 DECLARE
     i INTEGER;
 BEGIN
-    SELECT COUNT(*) INTO i FROM USER_CATALOG
-        WHERE TABLE_NAME = '%(sq_name)s' AND TABLE_TYPE = 'SEQUENCE';
+    SELECT COUNT(*) INTO i FROM ALL_CATALOG
+        WHERE TABLE_NAME = '%(sq_name)s' AND OWNER = '%(schema)s'
+              AND TABLE_TYPE = 'SEQUENCE';
     IF i = 0 THEN
-        EXECUTE IMMEDIATE 'CREATE SEQUENCE "%(sq_name)s"';
+        EXECUTE IMMEDIATE 'CREATE SEQUENCE %(qualified_sq_name)s';
     END IF;
 END;
-/""" % locals()
+/""" % params
         trigger_sql = """
-CREATE OR REPLACE TRIGGER "%(tr_name)s"
+CREATE OR REPLACE TRIGGER %(tr_name)s
 BEFORE INSERT ON %(tbl_name)s
 FOR EACH ROW
 WHEN (new.%(col_name)s IS NULL)
     BEGIN
-        SELECT "%(sq_name)s".nextval
+        SELECT %(qualified_sq_name)s.nextval
         INTO :new.%(col_name)s FROM dual;
     END;
-/""" % locals()
+/""" % params
         return sequence_sql, trigger_sql
 
     def date_extract_sql(self, lookup_type, field_name):
@@ -196,8 +205,10 @@
     def deferrable_sql(self):
         return " DEFERRABLE INITIALLY DEFERRED"
 
-    def drop_sequence_sql(self, table):
-        return "DROP SEQUENCE %s;" % self.quote_name(self._get_sequence_name(table))
+    def drop_sequence_sql(self, qname):
+        seq_name = self._get_sequence_name(qname)
+        qname = self.connection.ops.qualified_name(seq_name)
+        return "DROP SEQUENCE %s;" % qname
 
     def fetch_returned_insert_id(self, cursor):
         return long(cursor._insert_id_var.getvalue())
@@ -213,9 +224,9 @@
         # The DB API definition does not define this attribute.
         return cursor.statement
 
-    def last_insert_id(self, cursor, table_name, pk_name):
-        sq_name = self._get_sequence_name(table_name)
-        cursor.execute('SELECT "%s".currval FROM dual' % sq_name)
+    def last_insert_id(self, cursor, qualified_name, pk_name):
+        sq_name = self._get_sequence_name(qualified_name)
+        cursor.execute('SELECT %s.currval FROM dual' % sq_name)
         return cursor.fetchone()[0]
 
     def lookup_cast(self, lookup_type):
@@ -247,9 +258,23 @@
                                                self.max_name_length())
         return name.upper()
 
+    def qualified_name(self, qname):
+        assert isinstance(qname, QName)
+        schema = qname.schema
+        if not qname.db_format:
+            if not schema:
+                schema = self.connection.schema
+            schema = self.connection.convert_schema(schema)
+        if schema:
+            return "%s.%s" % (self.quote_name(schema),
+                              self.quote_name(qname.table))
+        else:
+            return self.quote_name(qname.table)
+
     def random_function_sql(self):
         return "DBMS_RANDOM.RANDOM"
 
+
     def regex_lookup_9(self, lookup_type):
         raise NotImplementedError("Regexes are not supported in Oracle before version 10g.")
 
@@ -284,46 +309,46 @@
             sql = ['%s %s %s;' % \
                     (style.SQL_KEYWORD('DELETE'),
                      style.SQL_KEYWORD('FROM'),
-                     style.SQL_FIELD(self.quote_name(table)))
+                     style.SQL_FIELD(self.qualified_name(table)))
                     for table in tables]
             # Since we've just deleted all the rows, running our sequence
             # ALTER code will reset the sequence to 0.
             for sequence_info in sequences:
-                sequence_name = self._get_sequence_name(sequence_info['table'])
-                table_name = self.quote_name(sequence_info['table'])
-                column_name = self.quote_name(sequence_info['column'] or 'id')
-                query = _get_sequence_reset_sql() % {'sequence': sequence_name,
-                                                     'table': table_name,
-                                                     'column': column_name}
-                sql.append(query)
+                q = self._sequence_reset_sql_for_col(
+                    sequence_info['qname'], sequence_info['column'] or 'id')
+                sql.append(q)
             return sql
         else:
             return []
 
+    def _sequence_reset_sql_for_col(self, qname, column):
+        qname = self.connection.introspection.qname_converter(qname)
+        qn = self.connection.ops.qualified_name
+        table = qn(qname)
+        sequence_name = self._get_sequence_name(qname)
+        column_name = self.quote_name(column)
+        params = {'sequence': sequence_name.table, 'table': table,
+                  'schema': sequence_name.schema.upper(), 'column': column_name}
+        query = _get_sequence_reset_sql(bool(params['schema']))
+        return query % params
+
     def sequence_reset_sql(self, style, model_list):
         from django.db import models
         output = []
-        query = _get_sequence_reset_sql()
         for model in model_list:
             for f in model._meta.local_fields:
                 if isinstance(f, models.AutoField):
-                    table_name = self.quote_name(model._meta.db_table)
-                    sequence_name = self._get_sequence_name(model._meta.db_table)
-                    column_name = self.quote_name(f.column)
-                    output.append(query % {'sequence': sequence_name,
-                                           'table': table_name,
-                                           'column': column_name})
+                    q = self._sequence_reset_sql_for_col(
+                        model._meta.qualified_name, f.column)
+                    output.append(q)
                     # Only one AutoField is allowed per model, so don't
                     # continue to loop
                     break
             for f in model._meta.many_to_many:
                 if not f.rel.through:
-                    table_name = self.quote_name(f.m2m_db_table())
-                    sequence_name = self._get_sequence_name(f.m2m_db_table())
-                    column_name = self.quote_name('id')
-                    output.append(query % {'sequence': sequence_name,
-                                           'table': table_name,
-                                           'column': column_name})
+                    q = self._sequence_reset_sql_for_col(
+                        f.m2m_qualified_name(), 'id')
+                    output.append(q)
         return output
 
     def start_transaction_sql(self):
@@ -377,13 +402,23 @@
             raise NotImplementedError("Bit-wise or is not supported in Oracle.")
         return super(DatabaseOperations, self).combine_expression(connector, sub_expressions)
 
-    def _get_sequence_name(self, table):
+    def _get_sequence_name(self, qname):
+        assert isinstance(qname, QName)
+        qname = self.connection.introspection.qname_converter(qname,
+                                                              force_schema=True)
         name_length = self.max_name_length() - 3
-        return '%s_SQ' % util.truncate_name(table, name_length).upper()
+        seq_name = '%s_SQ' % util.truncate_name(qname.table,
+                                                name_length).upper()
+        return QName(qname.schema, seq_name, True)
+        #return '%s_SQ' % util.truncate_name(name, name_length).upper()
 
-    def _get_trigger_name(self, table):
+    def _get_trigger_name(self, qname):
+        assert isinstance(qname, QName)
+        qname = self.connection.introspection.qname_converter(qname)
         name_length = self.max_name_length() - 3
-        return '%s_TR' % util.truncate_name(table, name_length).upper()
+        trig_name = '%s_TR' % util.truncate_name(qname.table,
+                                                 name_length).upper()
+        return self.qualified_name(QName(qname.schema, trig_name, True))
 
     def bulk_insert_sql(self, fields, num_values):
         items_sql = "SELECT %s FROM DUAL" % ", ".join(["%s"] * len(fields))
@@ -444,6 +479,13 @@
         self.creation = DatabaseCreation(self)
         self.introspection = DatabaseIntrospection(self)
         self.validation = BaseDatabaseValidation(self)
+    
+    def convert_schema(self, schema):
+        schema = schema or self.schema
+        if schema and self.test_schema_prefix:
+            return truncate_name('%s%s' % (self.test_schema_prefix, schema),
+                                 self.ops.max_name_length())
+        return schema
 
     def check_constraints(self, table_names=None):
         """
@@ -476,7 +518,11 @@
             conn_params = self.settings_dict['OPTIONS'].copy()
             if 'use_returning_into' in conn_params:
                 del conn_params['use_returning_into']
-            self.connection = Database.connect(conn_string, **conn_params)
+            try:
+                self.connection = Database.connect(conn_string, **conn_params)
+            except:
+                print conn_string
+                raise
             cursor = FormatStylePlaceholderCursor(self.connection)
             # Set oracle date to ansi date format.  This only needs to execute
             # once when we create a new connection. We also set the Territory
@@ -814,14 +860,29 @@
     return s
 
 
-def _get_sequence_reset_sql():
+def _get_sequence_reset_sql(with_schema=False):
     # TODO: colorize this SQL code with style.SQL_KEYWORD(), etc.
-    return """
+    if with_schema:
+        return """
 DECLARE
     table_value integer;
     seq_value integer;
 BEGIN
     SELECT NVL(MAX(%(column)s), 0) INTO table_value FROM %(table)s;
+    SELECT NVL(last_number - cache_size, 0) INTO seq_value FROM all_sequences
+           WHERE sequence_name = '%(sequence)s' AND sequence_owner = '%(schema)s';
+    WHILE table_value > seq_value LOOP
+        SELECT "%(schema)s"."%(sequence)s".nextval INTO seq_value FROM dual;
+    END LOOP;
+END;
+/"""
+    else:
+        return """
+DECLARE
+    table_value integer;
+    seq_value integer;
+BEGIN
+    SELECT NVL(MAX(%(column)s), 0) INTO table_value FROM %(table)s;
     SELECT NVL(last_number - cache_size, 0) INTO seq_value FROM user_sequences
            WHERE sequence_name = '%(sequence)s';
     WHILE table_value > seq_value LOOP
